Learn how to execute a SQL query to return features

A feature layer
In this tutorial, you’ll write code to perform SQL queries that return a subset of features
Prerequisites
Before starting this tutorial:
-
You need an ArcGIS Location Platform or ArcGIS Online account.
-
Your system meets the system requirements.
-
The ArcGIS Maps SDK for Qt, version 200.8.0 or later is installed.
-
The Qt 6.8.2 software development framework or later is installed.
Develop or Download
You have two options for completing this tutorial:
Option 1: Develop the code
To start the tutorial, complete the Display a map tutorial. This creates a map to display the Santa Monica Mountains in California using the topographic basemap from the ArcGIS Basemap Styles service
Open a Qt Creator project
- Open the project you created by completing the Display a map tutorial.
- Continue with the following instructions to execute a SQL query to return features from a feature layer based on spatial and attribute criteria.
Update the header file
This app will use various functions and member variables that need to be declared in the header file.
-
In Projects, double-click Headers > Display_a_map.h to open the file.
-
Forward declare the following classes.
Display_a_map.hnamespace Esri::ArcGISRuntime{class Map;class MapQuickView;class FeatureLayer;class ServiceFeatureTable;} -
Add the following code to define a function called
runQuerythat will be invokable from the GUI.Display_a_map.hpublic:explicit Display_a_map(QObject* parent = nullptr);~Display_a_map() override;Q_INVOKABLE void runQuery(const QString& expression); -
Finally, declare the following private function and member variables. Then save the file.
Display_a_map.hprivate:Esri::ArcGISRuntime::MapQuickView* mapView() const;void setMapView(Esri::ArcGISRuntime::MapQuickView* mapView);void setupViewpoint();void addFeatureLayer();Esri::ArcGISRuntime::FeatureLayer* m_featureLayer = nullptr;Esri::ArcGISRuntime::ServiceFeatureTable* m_featureTable = nullptr;
Include header files in the source code
To create this app you will need to include several class header files from the ArcGIS Maps SDK for Qt C++ API.
-
In Projects, double-click Sources > Display_a_map.cpp to open the file.
-
Add the following include statements needed for this tutorial.
Display_a_map.cpp#include "Display_a_map.h"#include "Map.h"#include "MapTypes.h"#include "MapQuickView.h"#include "Point.h"#include "Viewpoint.h"#include "SpatialReference.h"#include <QFuture>#include "Envelope.h"#include "Feature.h"#include "FeatureLayer.h"#include "LayerListModel.h"#include "FeatureIterator.h"#include "FeatureQueryResult.h"#include "QueryParameters.h"#include "SelectionProperties.h"#include "ServiceFeatureTable.h"#include <memory>#include <QColor>#include <QList>#include <QUuid>#include <QUrl>
Add a feature layer, query features, and select results
You will add three functions to add a feature layer from ArcGIS online, execute a query of that layer, and create a features list from the query result.
-
Staying within the Display_a_map.cpp file, add code to create the
addFeatureLayer()function. This function adds the LA_County_Parcels feature layer hosted on ArcGIS Online to the map.Display_a_map.cppvoid Display_a_map::setupViewpoint(){const Point center(-118.80543, 34.02700, SpatialReference::wgs84());const Viewpoint viewpoint(center, 100000.0);m_mapView->setViewpointAsync(viewpoint);}void Display_a_map::addFeatureLayer(){// Create a ServiceFeatureTable from a QUrl.m_featureTable = new ServiceFeatureTable(QUrl("https://services3.arcgis.com/GVgbJbqm8hXASVYi/arcgis/rest/services/LA_County_Parcels/FeatureServer/0"), this);// Create the feature layer using the feature table.m_featureLayer = new FeatureLayer(m_featureTable, this);// Add the feature layer to the map.m_map->operationalLayers()->append(m_featureLayer);} -
Continuing in the same file, add the
runQuery(const QString& expression)function to implement the query that will execute a query of the parcels layer. This function creates aQueryParametersobject that includes the currently visible map extent and a SQL expression, and then executes the query on the parcels table. When a query completes, the code iterates the returned results and adds those features to a list. That list is then used to select features in the parcels layer.Display_a_map.cppvoid Display_a_map::addFeatureLayer(){// Create a ServiceFeatureTable from a QUrl.m_featureTable = new ServiceFeatureTable(QUrl("https://services3.arcgis.com/GVgbJbqm8hXASVYi/arcgis/rest/services/LA_County_Parcels/FeatureServer/0"), this);// Create the feature layer using the feature table.m_featureLayer = new FeatureLayer(m_featureTable, this);// Add the feature layer to the map.m_map->operationalLayers()->append(m_featureLayer);}void Display_a_map::runQuery(const QString& expression){if (!m_featureTable)return;// Create a query parameter object and set the WhereClause.QueryParameters queryParams;queryParams.setGeometry(m_mapView->currentViewpoint(ViewpointType::BoundingGeometry).targetGeometry().extent());queryParams.setWhereClause(expression);m_featureTable->queryFeaturesAsync(queryParams).then(this,[this](FeatureQueryResult* rawQueryResult){if (!rawQueryResult)return;// Wrap the FeatureQueryResult in a unique_ptr to manage the memory effectively.auto queryResult = std::unique_ptr<FeatureQueryResult>(rawQueryResult);// Clear any existing selection.m_featureLayer->clearSelection();QList<Feature*> features;// Iterate over the result object.while(queryResult->iterator().hasNext()){Feature* feature = queryResult->iterator().next(this);// Add each feature to the list.features.append(feature);}// Select features.m_featureLayer->selectFeatures(features);});} -
Continuing within the Display_a_map.cpp file, locate the
setMapView(MapQuickView* mapView)function. Modify the function to call the newaddFeatureLayer()function and also set the color for displaying selected parcel layer features (or any other selection) in your map view. Note: by default, the selected features in the map view are displayed in cyan. Then save the file.Display_a_map.cpp// Set the view (created in QML)void Display_a_map::setMapView(MapQuickView* mapView){if (!mapView || mapView == m_mapView){return;}m_mapView = mapView;m_mapView->setMap(m_map);addFeatureLayer();m_mapView->setSelectionProperties(SelectionProperties(QColor(Qt::yellow)));setupViewpoint();emit mapViewChanged();}
Show a list of query expressions for the user to choose from
You will create a UI that allows the user to choose from a list of predefined query expressions. The expressions are presented in a ComboBox control and when the user makes a choice, the expression is passed to the runQuery method to find parcels that meet the selected criterion within the currently visible map extent.
-
In Projects, double-click Resources > qml\qml.qrc/qml/Display_a_mapForm.qml to open the file.
-
Add the following code to create a
ComboBoxcontrol to execute a predefined query expression.Display_a_mapForm.qml// Declare the C++ instance that creates the map etc., and supply the view.Display_a_map {id: modelmapView: view}ComboBox {id: queryComboBoxanchors {left: parent.lefttop: parent.topmargins: 15}property int bestWidth: implicitWidthwidth: bestWidth + leftPadding + rightPaddingmodel: ["Choose a SQL where clause","UseType = 'Government'","UseType = 'Residential'","UseType = 'Irrigated Farm'","TaxRateArea = 10853","TaxRateArea = 10860","Roll_LandValue > 1000000","Roll_LandValue < 1000000"]onCurrentTextChanged: {model.runQuery(queryComboBox.currentText)}}
Set developer credentials
For the final steps of this tutorial, click the tab below that corresponds to the authentication type (API key authentication or User authentication) that you chose when you completed the Display a map tutorial.
Be sure to also provide the same authentication (API key or user authentication Client ID/Redirect URL) that you used for the Display a map tutorial.
Set the API Key
-
In the project Sources folder of Qt Creator, open the main.cpp file.
-
Modify the code to set the
accessTokenusing your API key access token (highlighted in yellow).main.cpp// The following methods grant an access token:// 1. User authentication: Grants a temporary access token associated with a user's ArcGIS account.// To generate a token, a user logs in to the app with an ArcGIS account that is part of an// organization in ArcGIS Online or ArcGIS Enterprise.// 2. API key authentication: Get a long-lived access token that gives your application access to// ArcGIS location services. Go to the tutorial at https://links.esri.com/create-an-api-key.// Copy the API Key access token.const QString accessToken = QString("");if (accessToken.isEmpty()){qWarning() << "Use of ArcGIS location services, such as the basemap styles service, requires" <<"you to authenticate with an ArcGIS account or set the API Key property.";}else{ArcGISRuntimeEnvironment::setApiKey(accessToken);} -
Save the main.cpp file.
Best Practice: The access token is stored directly in the code as a convenience for this tutorial. Do not store credentials directly in source code in a production environment.
Set path to the Qt Toolkit in the project
In the project Sources folder of Qt Creator, open the Display_a_map.pro file and locate the following lines and update PATH_TO_TOOLKIT variable with the path of the toolkitcpp.pri file (highlighted in yellow) or the OAuth dialog will not appear to enter your user credentials. Then save the file.
ARCGIS_RUNTIME_VERSION = 200.8.2include($$PWD/arcgisruntime.pri)
# TODO: You need to replace the <path_to_toolkit_repo> with a valid location where the Qt Toolkit# resides on your system, example: C:/arcgis-maps-sdk-toolkit-qt/uitools/toolkitcpp/toolkitcpp.pri# This block determines whether you've cloned your toolkitPATH_TO_TOOLKIT = "<path_to_toolkit_repo>/uitools/toolkitcpp/toolkitcpp.pri"
exists($${PATH_TO_TOOLKIT}) { message("Toolkit found") DEFINES += TOOLKIT_FOUND
# include the toolkitcpp.pri, which contains all the toolkit resources include($${PATH_TO_TOOLKIT})
qtHaveModule(webenginequick) { QT += webenginequick }} else { message("Toolkit not found in provided path. Either set PATH_TO_TOOLKIT or use an API Key")}Set developer credentials in the solution
In the project Sources folder of Qt Creator, open the Display_a_map.cpp file.
Set your values for the REDIRECT_URL and the CLIENT_ID strings (highlighted in yellow). Then save the file.
{
#ifdef TOOLKIT_FOUND
// Define the Redirect URL string obtained when creating the OAuth credentials. // TODO: You need to replace the "REDIRECT_URL" with your own valid string, // ex: "urn:ietf:wg:oauth:2.0:oob" const auto qStringRedirectUrl = QString{"REDIRECT_URL"};
// Define the URL of the portal to authenticate with. const QUrl qUrlPortal = QUrl{"https://www.arcgis.com/"};
// Define a unique identifier associated with an application registered with the // portal that assists with client/server OAuth authentication. // TODO: You need to replace the "CLIENT_ID" with your own valid string. const QString qStringClientId = QString{"CLIENT_ID"};
// Create a new OAuth user configuration using: the Url to mapping web service, the Client ID // string, and the Redirect Url string. auto* oAuthUserConfiguration = new OAuthUserConfiguration(qUrlPortal, qStringClientId, qStringRedirectUrl, this);
// Call the Toolkit's OAuthUserConfigurationManager static `addConfiguration` // method to use the OAuth dialog. This will tell the Authenticator to use OAuth for the provided configuration. Toolkit::OAuthUserConfigurationManager::addConfiguration(oAuthUserConfiguration);#endif // TOOLKIT_FOUNDPress Ctrl + R to run the app.
The app loads with the map centered on the Santa Monica Mountains in California with the parcels feature layer displayed. Choose an attribute expression, and parcels in the current extent that meet the selected criteria will display in the specified selection color.
Alternatively, you can download the tutorial solution, as follows.
Option 2: Download the solution
-
Click the
Download solutionlink underSolutionand unzip the file to a location on your machine. -
Open the .pro project file in Qt Creator.
Since the downloaded solution does not contain authentication credentials, you must set up authentication to create the developer credentials and add them to the project.
For the final steps of this tutorial, click the tab below that corresponds to the authentication type (API key authentication or User authentication) that you chose when you completed the Display a map tutorial.
Be sure to also provide the same authentication (API key or user authentication Client ID/Redirect URL) that you used for the Display a map tutorial.
Set developer credentials in the solution
Set the API Key
-
In the project Sources folder of Qt Creator, open the main.cpp file.
-
Modify the code to set the
accessTokenusing your API key access token (highlighted in yellow).main.cpp// The following methods grant an access token:// 1. User authentication: Grants a temporary access token associated with a user's ArcGIS account.// To generate a token, a user logs in to the app with an ArcGIS account that is part of an// organization in ArcGIS Online or ArcGIS Enterprise.// 2. API key authentication: Get a long-lived access token that gives your application access to// ArcGIS location services. Go to the tutorial at https://links.esri.com/create-an-api-key.// Copy the API Key access token.const QString accessToken = QString("");if (accessToken.isEmpty()){qWarning() << "Use of ArcGIS location services, such as the basemap styles service, requires" <<"you to authenticate with an ArcGIS account or set the API Key property.";}else{ArcGISRuntimeEnvironment::setApiKey(accessToken);} -
Save main.cpp file.
Best Practice: The access token is stored directly in the code as a convenience for this tutorial. Do not store credentials directly in source code in a production environment.
Set path to the Qt Toolkit in the project
In the project Sources folder of Qt Creator, open the Display_a_map.pro file and locate the following lines and update PATH_TO_TOOLKIT variable with the path of the toolkitcpp.pri file (highlighted in yellow) or the OAuth dialog will not appear to enter your user credentials. Then save the file.
ARCGIS_RUNTIME_VERSION = 200.8.2include($$PWD/arcgisruntime.pri)
# TODO: You need to replace the <path_to_toolkit_repo> with a valid location where the Qt Toolkit# resides on your system, example: C:/arcgis-maps-sdk-toolkit-qt/uitools/toolkitcpp/toolkitcpp.pri# This block determines whether you've cloned your toolkitPATH_TO_TOOLKIT = "<path_to_toolkit_repo>/uitools/toolkitcpp/toolkitcpp.pri"
exists($${PATH_TO_TOOLKIT}) { message("Toolkit found") DEFINES += TOOLKIT_FOUND
# include the toolkitcpp.pri, which contains all the toolkit resources include($${PATH_TO_TOOLKIT})
qtHaveModule(webenginequick) { QT += webenginequick }} else { message("Toolkit not found in provided path. Either set PATH_TO_TOOLKIT or use an API Key")}Set developer credentials in the solution
-
In the project Sources folder of Qt Creator, open the Display_a_map.cpp file.
-
Set your values for the REDIRECT_URL and the CLIENT_ID strings (highlighted in yellow). Then save the file.
{
#ifdef TOOLKIT_FOUND
// Define the Redirect URL string obtained when creating the OAuth credentials. // TODO: You need to replace the "REDIRECT_URL" with your own valid string, // ex: "urn:ietf:wg:oauth:2.0:oob" const auto qStringRedirectUrl = QString{"REDIRECT_URL"};
// Define the URL of the portal to authenticate with. const QUrl qUrlPortal = QUrl{"https://www.arcgis.com/"};
// Define a unique identifier associated with an application registered with the // portal that assists with client/server OAuth authentication. // TODO: You need to replace the "CLIENT_ID" with your own valid string. const QString qStringClientId = QString{"CLIENT_ID"};
// Create a new OAuth user configuration using: the Url to mapping web service, the Client ID // string, and the Redirect Url string. auto* oAuthUserConfiguration = new OAuthUserConfiguration(qUrlPortal, qStringClientId, qStringRedirectUrl, this);
// Call the Toolkit's OAuthUserConfigurationManager static `addConfiguration` // method to use the OAuth dialog. This will tell the Authenticator to use OAuth for the provided configuration. Toolkit::OAuthUserConfigurationManager::addConfiguration(oAuthUserConfiguration);#endif // TOOLKIT_FOUNDRun the solution
Press Ctrl + R to run the app.
The app loads with the map centered on the Santa Monica Mountains in California with the parcels feature layer displayed. Choose an attribute expression, and parcels in the current extent that meet the selected criteria will display in the specified selection color.
What’s next?
Learn how to use additional API features, ArcGIS location services, and ArcGIS tools in these tutorials: